{% set isAllowed = is_granted('ROLE_SERVICE_COMMITTEE') or (compilation.serviceGroup.overseer or compilation.serviceGroup.assistant) is same as app.user.publisher %}
{% extends 'base.html.twig' %}
{% block header_title %}
    Rapport d'activité de prédication
    <div class="badge bg-success badge-md">{{ compilation.date|format_date('none', 'MMMM Y', locale='fr')|upper }}</div>
{% endblock %}
{% block header_subtitle %}{{ compilation.serviceGroup.name }}{% endblock %}

{% block body %}
    {% for message in app.flashes('success') %}
        <div class="row mt-2">
            <div class="col-xxl-3">
                <div class="alert alert-fill alert-icon alert-success">
                    <em class="icon ni ni-check-circle-fill"></em>
                    {{ message }}
                </div>
            </div>
        </div>
    {% endfor %}
    <div class="col-xxl-12 col-sm-12 col-md-12 col-12">
        <form action="" method="post" id="formCreate">
            <div class="card card-bordered card-preview">
                <div class="nk-tb-list nk-tb-orders">
                    <div class="nk-tb-item nk-tb-head">
                        <div class="nk-tb-col tb-col"><span>Proclamateur</span></div>
                        <div class="nk-tb-col tb-col-md"><span>Heures</span></div>
                        <div class="nk-tb-col tb-col-md"><span>Nouv. visites</span></div>
                        <div class="nk-tb-col tb-col-md"><span>Cours bibl.</span></div>
                        <div class="nk-tb-col tb-col-md"><span>Publications</span></div>
                        <div class="nk-tb-col tb-col-md"><span>Vidéos</span></div>
                        <div class="nk-tb-col tb-col-md"><span>Autre (LDC/Bethel)</span></div>
                        <div class="nk-tb-col tb-col-md"><span>Observations</span></div>
                        <div class="nk-tb-col"><span>&nbsp;</span></div>
                    </div>
                    {% for reportForm in form.reports %}
                        <div class="nk-tb-item">
                            <div class="nk-tb-col">
                                <div class="user-card">
                                    <div class="user-name">
                                        <a target="_blank" href="{{ path('app_publisher_show', {'id': reportForm.vars.data.publisher.id}) }}" class="btn-link"><span class="tb-lead">{{ reportForm.vars.data.publisher.fullName }}</span></a>
                                    </div>
                                </div>
                            </div>
                            <div class="nk-tb-col tb-col-md">
                                <input type="text" class="form-control displayedTimes" placeholder="ex: 13h15" id="formatTimeInput">
                                {{ form_widget(reportForm.times) }}
                            </div>
                            <div class="nk-tb-col tb-col-md">
                                <div>
                                    <div>
                                        <span>{{ form_widget(reportForm.visits) }}</span>
                                    </div>
                                </div>
                            </div>
                            <div class="nk-tb-col tb-col-md">
                                <div>
                                    <div>
                                        <span>{{ form_widget(reportForm.courses) }}</span>
                                    </div>
                                </div>
                            </div>
                            <div class="nk-tb-col tb-col-md">
                                <div>
                                    <div>
                                        <span>{{ form_widget(reportForm.publications) }}</span>
                                    </div>
                                </div>
                            </div>
                            <div class="nk-tb-col tb-col-md">
                                <div>
                                    <div>
                                        <span>{{ form_widget(reportForm.videos) }}</span>
                                    </div>
                                </div>
                            </div>
                            <div class="nk-tb-col tb-col-md">
                                <div>
                                    <div>
                                        <span>{{ form_widget(reportForm.otherTimes) }}</span>
                                    </div>
                                </div>
                            </div>
                            <div class="nk-tb-col tb-col-md">
                                <div>
                                    <div>
                                        <span>{{ form_widget(reportForm.comment) }}</span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    {% endfor %}
                </div>
                {% if compilation.closed == false and isAllowed or is_granted('ROLE_SECRETARY') %}
                    <div class="form-group m-2">
                        {{ form_widget(form.closed) }}
                    </div>
                    <div class="row">
                        <div class="col-lg-12 m-2">
                            {{ form_widget(form._token) }}
                            <button class="btn btn-primary btn-submit" type="submit">Valider</button>
                        </div>
                    </div>
                    {% elseif compilation.closed %}
                    <div class="alert alert-warning">La compilation des rapports a été clôturée. Pour établir une modification, contacte le secrétaire de ton assemblée.</div>
                {% endif %}
            </div><!-- .card-preview -->
        </form>
    </div><!-- .col -->
{% endblock %}
{% block javascripts %}
    <script>
        const $timeDisplayedList = $('.displayedTimes');

        for (let i=0; i < $timeDisplayedList.length; i++) {
            const $timeDisplayed = $timeDisplayedList.eq(i);
            const $timeHidden = $('.time-input-report').eq(i);

            $timeDisplayed.val(formatTime($timeHidden.val()))

            $timeDisplayed.change(function (e){

                let value = $timeDisplayed.val();
                let timeSplit = splitTimeMinute(value);
                const hour = parseInt(timeSplit[0]);
                const minutes = parseInt(timeSplit[1]);

                if ((minutes > 0 && minutes % 15 !== 0) || minutes > 45) {
                    $timeDisplayed.addClass('error');
                    $('.btn-submit').prop('disabled', true);

                } else {
                    if ($(this).hasClass('error')) {
                        $(this).removeClass('error')
                        $('.btn-submit').prop('disabled', false)
                    }
                }


                const timeInMinutes = (hour * 60) + minutes;
                $timeHidden.val(timeInMinutes);

                if (isNaN(timeInMinutes)) {
                    $timeHidden.val(0)
                }
            })

        }

        function splitTimeMinute(str) {
            const minuteSymbole = ['H', 'h', ':', ',', ':'];
            let result = str;
            minuteSymbole.forEach(function(smb, index) {
                let split = str.split(smb);
                if (split.length > 1) {
                    result = split;
                }
            })

            if (result.length === 1) {
                return [result[0], '0'];
            }
            if (result[1] === '') {
                return [result[0], '0'];
            }

            if (!Array.isArray(result)) {
                return [result, '0'];
            }

            return result;
        }

        function formatTime(val) {
            const m = val % 60;
            const h = (val-m)/60;

            return (h < 10 ? "0" : "") + h.toString() + ":" + (m < 10 ? "0" : "") + m.toString();
        }


        const $otherTimes = $('.otherTimes');

        for (let i=0; i < $otherTimes.length; i++) {
            const val = $otherTimes.eq(i).val();
            const timeInHour = formatOtherTime(val);
            $otherTimes.eq(i).val(timeInHour);
        }

        function formatOtherTime(value) {
            return value / 60;
        }

    </script>
{% endblock %}
